/* small trampoline code to start the main application
 *
 * Written 2013 by Ingo Korb, no copyright claimed
 */

#include "asmconfig.h"

/* address definitions */
/* CMSIS only provides C structs, nothing assembler-friendly */
#define VTOR_Offset 8

        .syntax unified

        .section .text

        .global start_app
        .thumb_func

start_app:
        /* change vector table offset */
        ldr     r0, =APPLICATION_OFFSET
        ldr     r1, =SCB_BASE
        str     r0, [r1, #VTOR_Offset]

        /* load stack pointer */
        ldr     sp, [r0]
        
        /* load start address */
        ldr     r1, [r0, #4]

        /* jump to main code */
        bx      r1

        .end
